<?php
/*
※ファイルのURL→http://～/d/年/月日/UNIXTime.拡張子
*/

new UPLOAD();

class UPLOAD{
	private $savedir = 'd';
	private $filepermission  = 0666;
	private $blacklist = array('php', 'cgi', 'fcgi', 'pl', 'py', 'rb', 'asp', 'aspx', 'jsp', 'htaccess', 'htpasswd');//ホワイトリスト形式にすべきだが
	private $html = array();
	
	function UPLOAD(){
		error_reporting(0);
		session_start();
		$this->html['php_upload_max_filesize'] = ini_get('upload_max_filesize');
		$this->html['php_post_max_size']       = ini_get('post_max_size');
		$this->html['php_max_file_uploads']    = ini_get('max_file_uploads');
		$this->html['limitbyte'] = preg_replace('/M/i', '', $this->html['php_post_max_size']);//決め打ち
		$this->html['limitbyte'] = $this->html['limitbyte'] * 1000 *1000;
		

		if($_SERVER['REQUEST_METHOD'] == 'POST'){
			$this->RecieveUpload();
		}
		else{
			$_SESSION['time'] = $_SERVER['REQUEST_TIME'];
			$this->html['time'] = $_SERVER['REQUEST_TIME'];
			$this->PrintTopPageTemplate();
		}
	}

	
	function RecieveUpload(){
		if($_SESSION['time'] != $_GET['time']){
			$this->html['p'] = '二重投稿です。';
			$this->PrintErrorTemplate();
		}
		unset($_SESSION['time']);
		
		if ($_FILES[uploadfile][error] === UPLOAD_ERR_OK and $_FILES[uploadfile][name]){//単数
			$this->SaveFile($_FILES[uploadfile][tmp_name], $_FILES[uploadfile][name], $_SERVER['REQUEST_TIME']);
		}
		elseif($_FILES[uploadfile][error][0] === UPLOAD_ERR_OK and $_FILES[uploadfile][name][0]){//複数
			for ($i=0; $i<$this->html['php_max_file_uploads']; $i++) {
				if($_FILES[uploadfile][error][$i] != 0 or !$_FILES[uploadfile][name][$i]){ break; }
				$this->SaveFile($_FILES[uploadfile][tmp_name][$i], $_FILES[uploadfile][name][$i], $_SERVER['REQUEST_TIME']+$i);
			}
		}
		elseif($_FILES[uploadfile][error] === UPLOAD_ERR_NO_FILE or $_FILES[uploadfile][error][0] === UPLOAD_ERR_NO_FILE){//失敗
			$this->html['p'] = 'ファイルを選択してください。';
			$this->PrintErrorTemplate();
		}
		else{//失敗
			$this->html['p'] = 'アップロードに失敗しました。';
			$this->PrintErrorTemplate();
		}
		
		$y  = date('Y',  $_SERVER['REQUEST_TIME']);
		$md = date('md', $_SERVER['REQUEST_TIME']);
		$this->html['copyform'] = $this->ReturnCopyForm();
		$this->html['resulttable'] = "<table><tr><th>ファイル</th><th>URL</th></tr>\n{$this->html['tr']}</table>";
		$this->html['link'] = "<a href=\"uplist.php?y={$y}&md={$md}\">アップリスト</a>";

		$this->PrintSuccessTemplate();
	}


	function SaveFile($tmpfile, $upfile, $time){
		$savedir1 = date('Y'   , $time);
		$savedir2 = date('md'  , $time);
		$filename = $time;
		
		$this->MakeDir($this->savedir, $savedir1);
		$this->MakeDir("$this->savedir/$savedir1", $savedir2);

		$extension = pathinfo($upfile, PATHINFO_EXTENSION);
		if($extension){
			if(!ctype_alnum($extension)){
				$this->html['p'] = '拡張子は英数字限定です。';
				$this->PrintErrorTemplate();
			}
			foreach($this->blacklist as $ng){
				if($ng == $extension){ $extension = 'txt'; }
			}
			$filename = "$filename.$extension";
		}

		$filepath = "$this->savedir/$savedir1/$savedir2/{$filename}";
		if(@move_uploaded_file($tmpfile, $filepath) === false){
			$this->html['p'] = 'ファイルが作成できません';
			$this->PrintErrorTemplate();
		}
		chmod($filepath, $this->filepermission);

		$fileurl = $this->Path2URL($filepath);
		$upfile = htmlspecialchars($upfile);
		
		$fromencode = 'auto';
		//if(preg_match("/Windows/i", $_SERVER['HTTP_USER_AGENT'])){ $fromencode = "SJIS"; }
		$upfile = mb_convert_encoding($upfile, 'UTF-8', $fromencode);
		
		$this->html['tr'] .= "<tr><td><a href=\"$fileurl\" target=\"_blank\">$upfile</a></td><td>$fileurl</td></tr>\n";
		$this->html['fileurl'] .= "$fileurl\n";
	}


	function MakeDir($path, $name){//ディレクトリを作るパスとディレクトリ名を頂戴
		if(!is_dir("$path/$name")){
			$permission = substr(decoct(fileperms($path)), 1);
			$flag = mkdir("$path/$name", octdec($permission));// umaskでパーミッションが減るから
			chmod("$path/$name", octdec($permission));// ここで元に戻す
			if(!$flag){
				$this->html['p'] = 'ディレクトリが作成できません';
				$this->PrintErrorTemplate();
			}
		}
	}


	function Path2URL($path){ //相対パスを頂戴
		if($_SERVER['HTTPS']=='on'){ $protocol = 'https://'; }
		else{ $protocol = 'http://'; }
		
		$dir_url = preg_replace('/\/[^\/]*$/', '/', $_SERVER['REQUEST_URI']); //$_SERVER['REQUEST_URI']からファイル名以下を消す
		$dir_url = preg_replace('/^\//', '', $dir_url); //先頭の/が邪魔なので消しておく

		$path = preg_replace('/^\.\//', '', $path); //現在のフォルダに対応
		if(preg_match('/^\.\.\//', $path)){ //上位のフォルダに対応する
			$path = str_replace('../', '', $path, $count);
			$dirlist = explode('/', $dir_url);
			array_splice($dirlist, -$count-1);
			if(count($dirlist)>0){
				$dir_url = implode('/', $dirlist) . '/';
			}
			else{
				$dir_url = '';
			}
		}

		$url = $protocol . $_SERVER['HTTP_HOST'] . '/' . $dir_url . $path;
		return $url;
	}


	function PrintTopPageTemplate(){
		print <<<PHPHereDocument
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップローダ</title>
  <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
  <link href="style.css" rel="stylesheet">
</head>
<body id="upload">
<nav><a href="uplist.php">アップリスト</a></nav>
<form action="upload.php?time={$this->html['time']}" method="POST" enctype="multipart/form-data" id="upform">
<input type="hidden" name="MAX_FILE_SIZE" value="{$this->html['limitbyte']}">
<input type="file" class="upfile" name="uploadfile[]" onchange="add_file('uploadfile', 1);"><br>
<span id="uploadfile_1"></span>
<input type="submit" class="upsubmit" name="submit" value="ファイルをアップロードする">
<p class="mininote">※合計<strong>{$this->html['php_post_max_size']}B</strong>までアップロードできます。</p>
</form>

<script language="JavaScript">
function add_file(id, i) {
	var elements = document.getElementsByName("uploadfile[]");
	if (elements.length >= {$this->html['php_max_file_uploads']}){ return; }
	if (document.getElementById(id + '_' + i).innerHTML.search('upfile') == -1) {
		document.getElementById(id + '_' + i).innerHTML = '<input type="file" class="upfile" name="' + id + '[]" onchange="return add_file(\'' + id + '\', ' + (i+1) + ');" /><br /><span id="' + id + '_' + (i+1) + '"><\/span>';
	}
}
</script>
</body>
</html>
PHPHereDocument;
		exit;
	}
	
	
	function PrintErrorTemplate(){
		header("Cache-Control: no-cache");
		print <<<PHPHereDocument
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップローダ</title>
  <link href="style.css" rel="stylesheet">
</head>
<body>

<p class="error">{$this->html['p']}</p>

<br><a href="upload.php">アップローダ</a>
</body>
</html>

PHPHereDocument;
		exit;
	}


	function PrintSuccessTemplate(){
		header("Cache-Control: no-cache");
		print <<<PHPHereDocument
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップローダ</title>
  <link href="style.css" rel="stylesheet">
</head>
<body>

<p class="success">アップロードに成功しました。URLをコピーしておいてください。</p>
{$this->html['copyform']}
{$this->html['resulttable']}

<br>{$this->html['link']}
</body>
</html>

PHPHereDocument;
		exit;
	}
	

	function ReturnCopyForm(){
		return <<<PHPHereDocument
<object id="external_setclipboard" width="110" height="25" align="middle" classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000">
<param name="movie" value="setClipboard10.swf">
<param name="FlashVars" value="htmlid=copypaste&label=URLをコピーする">
<param name="allowScriptAccess" value="sameDomain">
</object><br>
<textarea style="display:none;" cols="100" rows="10" id="copypaste">{$this->html['fileurl']}</textarea>
PHPHereDocument;
	}

}